/*
	You *must* include stdio.h, conio.h, and stdlib.h
        These routines are for a 320x200, 256 color PCX file *only*
*/

int showpcx(char *fname);
void loadpcxpix(char *fname, unsigned char *where);
void loadpcxpal(char *fname, unsigned char *where);
void showpcxpal(char *fname);

int showpcx(char *fname){
        FILE *file;
        unsigned int loopvar;
        unsigned char pal[3];
        char *VID=(char *)0x0a0000;
        unsigned int count=0;
        unsigned char byte;

        if((file=fopen(fname, "rb"))==NULL){
                deinit256();
                printf("showpcx();\nError: Could not open %s for read\n",fname);
                exit(1);
        }

        for(loopvar=0;loopvar<128;loopvar++){
                fgetc(file);
        }

        do{
                byte=fgetc(file);
                loopvar=1;

                if(byte>192){
                        byte-=192;
                        loopvar=byte;
                        byte=fgetc(file);
                }

                for(;loopvar!=0;loopvar--){
                        *(VID+count)=byte;
                        count++;
                }

        }while(count<64000);
        fseek(file, -768, SEEK_END);
        for(loopvar=0;loopvar<256;loopvar++){
                pal[0]=fgetc(file)>>2;
                pal[1]=fgetc(file)>>2;
                pal[2]=fgetc(file)>>2;
                setpal(loopvar,pal[0],pal[1],pal[2]);
        }
        fclose(file);
        return 0; /* success */
}


void loadpcxpix(char *fname, unsigned char *where){
        FILE *file;
        unsigned int loopvar;
        unsigned int count=0;
        unsigned char byte;

        if((file=fopen(fname, "rb"))==NULL){
                deinit256();
                printf("loadpcxpix();\nError: Could not open %s for read\n",fname);
                exit(1);
        }

        for(loopvar=0;loopvar<128;loopvar++){
                fgetc(file);
        }

        do{
                byte=fgetc(file);
                loopvar=1;

                if(byte>192){
                        byte-=192;
                        loopvar=byte;
                        byte=fgetc(file);
                }

                for(;loopvar!=0;loopvar--){
                        *(where+count)=byte;
                        count++;
                }

        }while(count<64000);
        fclose(file);
}

void loadpcxpal(char *fname, unsigned char *where){
        FILE *file;
        unsigned int loopvar;
        unsigned int count=0;

        if((file=fopen(fname, "rb"))==NULL){
                deinit256();
                printf("loadpcxpal();\nError: Could not open %s for read\n",fname);
                exit(1);
        }

        fseek(file, -768, SEEK_END);
        for(loopvar=0;loopvar<256;loopvar++){
                where[count]=fgetc(file)>>2;
                count++;
                where[count]=fgetc(file)>>2;
                count++;
                where[count]=fgetc(file)>>2;
                count++;
        }
        fclose(file);

}

void showpcxpal(char *fname){
        FILE *file;
        unsigned int loopvar;
        unsigned char pal[3];
           
        if((file=fopen(fname, "rb"))==NULL){
                deinit256();
                printf("showpcxpal();\nError: Could not open %s for read\n",fname);
                exit(1);
        }
        fseek(file, -768, SEEK_END);
        for(loopvar=0;loopvar<256;loopvar++){
                pal[0]=fgetc(file)>>2;
                pal[1]=fgetc(file)>>2;
                pal[2]=fgetc(file)>>2;
                setpal(loopvar,pal[0],pal[1],pal[2]);
        }
        fclose(file);
        

}

